<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBoolValuePair ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBoolValuePair
 * @subpackage Arrays
 */
class ArrayOfBoolValuePair extends AbstractStructArrayBase
{
    /**
     * The BoolValuePair
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var BoolValuePair[]
     */
    public $BoolValuePair;
    /**
     * Constructor method for ArrayOfBoolValuePair
     * @uses ArrayOfBoolValuePair::setBoolValuePair()
     * @param BoolValuePair[] $boolValuePair
     */
    public function __construct(array $boolValuePair = array())
    {
        $this
            ->setBoolValuePair($boolValuePair);
    }
    /**
     * Get BoolValuePair value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return BoolValuePair[]|null
     */
    public function getBoolValuePair()
    {
        return isset($this->BoolValuePair) ? $this->BoolValuePair : null;
    }
    /**
     * Set BoolValuePair value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param BoolValuePair[] $boolValuePair
     * @return ArrayOfBoolValuePair
     */
    public function setBoolValuePair(array $boolValuePair = array())
    {
        if (is_null($boolValuePair) || (is_array($boolValuePair) && empty($boolValuePair))) {
            unset($this->BoolValuePair);
        } else {
            $this->BoolValuePair = $boolValuePair;
        }
        return $this;
    }
    /**
     * Add item to BoolValuePair value
     * @throws \InvalidArgumentException
     * @param BoolValuePair $item
     * @return ArrayOfBoolValuePair
     */
    public function addToBoolValuePair(BoolValuePair $item)
    {
        $this->BoolValuePair[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return BoolValuePair|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return BoolValuePair|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return BoolValuePair|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return BoolValuePair|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return BoolValuePair|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BoolValuePair
     */
    public function getAttributeName()
    {
        return 'BoolValuePair';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return ArrayOfBoolValuePair
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
